#include"animk.hpp"




namespace{


enum{
  w = 6,
  h = 2,
};


Paper*
entries[h][w];


uint32_t
last;


int
i;


int
drew_flag;


void
draw(Area&  area)
{
    if(!drew_flag)
    {
      auto  ent = entries[0][i];

        if(!ent)
        {
          return;
        }


      area.fill(palette8.get_color(0));

      ent->draw(area,0,0,nullptr,1,palette8);

      ent = entries[1][i];

        if(ent)
        {
          ent->draw(area,0,0,nullptr,1,palette8);
        }


      drew_flag = 1;
    }
}


void
touch(Area&  area, const Mouse&  mouse)
{
  auto  pt = area.get_relative_point(mouse);

  const int  x = (pt.x/Card::w);
  const int  y = (pt.y/Card::h);

    if(mouse.test_left_pressing())
    {
      entries[y][x] = &holder.get_a_paper();

      anim.widgets.entry_area->request_redraw();
    }

  else
    if(mouse.test_right_pressing())
    {
      entries[y][x] = nullptr;

      anim.widgets.entry_area->request_redraw();
    }
}


void
draw_entries(Area&  area)
{
    if(!drew_flag)
    {
      area.fill(palette8.get_color(0));

        rep(y,h){
        rep(x,w){
            if(entries[y][x])
            {
              entries[y][x]->draw(area,Card::w*x,Card::h*y,nullptr,1,palette8);
            }

          else
            {
              area.draw_rect(Card::w*x  ,Card::h*y  ,Card::w  ,Card::h  ,     gray_color);
              area.fill_rect(Card::w*x+1,Card::h*y+1,Card::w-2,Card::h-2,dark_gray_color);
            }
        }}
    }
}


}




void
Anim::Widgets::
initialize()
{
  ctrl_widget = new TableRow;

  drawing_area = new Area(Card::w,
                          Card::h);

  drawing_area->set_draw_callback(draw);


  entry_area = new Area(Card::w*w,
                        Card::h*h);

  entry_area->set_callback(touch);
  entry_area->set_draw_callback(draw_entries);


  auto  col1 = new TableColumn;

  col1->insert(drawing_area);


  ctrl_widget->insert(entry_area);
  ctrl_widget->insert(col1);
}




void
Anim::Widgets::
update()
{
  auto  now = SDL_GetTicks();

    if(now >= last+200)
    {
      last = now;

        if(drew_flag)
        {
          drew_flag = 0;

          ++i;
        }


REDO:
        if(i >= w)
        {
          i = 0;
        }

      else
        if(!entries[0][i])
        {
          ++i;

          goto REDO;
        }


      drawing_area->request_redraw();
        entry_area->request_redraw();
    }
}




