#include"animk.hpp"




Anim  anim;

Holder  holder;


namespace{


Widget*
create_paint_widget()
{
  Node*  view = new TableColumn;

  view->insert(painter::widgets.brush_label );
  view->insert(painter::widgets.drawing_area);


  Node*  tools = new TableColumn;

  tools->insert(painter::widgets.radiobox);
  tools->insert(painter::widgets.revolve_widget);
  tools->insert(painter::widgets.reverse_widget);
  tools->insert(painter::widgets.mirror_widget);
  tools->insert(painter::widgets.shift_ud_widget);
  tools->insert(painter::widgets.shift_lr_widget);
  tools->insert(painter::widgets.undo_button);
  tools->insert(painter::widgets.copy_button);
  tools->insert(painter::widgets.grid_button);


  Node*  nd = new TableRow;

  nd->insert(view);
  nd->insert(tools);

  return nd;
}


Widget*
create_palette_widget()
{
  Node*  pal = new TableRow;

  pal->insert(palette8.widgets.area    );
  pal->insert(colorchooser.widgets.node);

  return pal;
}


void
update_painter()
{
  holder.widgets.drawing_area->request_redraw();
}


}


Widget*
create_united_widget()
{
  Node*  nd = new Node;

  colorchooser.widgets.initialize();
  palette8.widgets.initialize();
  anim.widgets.initialize();
  holder.widgets.initialize();

    rep(i,6)
    {
      int  l = (i? ((i<<5)|0b11111):0);

      palette8.set_color(i,l,l,l);
    }


  painter::set_relative_widgets({holder.widgets.drawing_area,anim.widgets.drawing_area,anim.widgets.entry_area});

  painter::reset_drawing(holder.get_a_paper());
  painter::push_showing(holder.get_a_paper());
  painter::reset_whole(Card::w,Card::h,6);

  painter::widgets.initialize();


  nd->insert(holder.widgets.table,0,0);
  nd->insert(anim.widgets.ctrl_widget,540,320);

  nd->insert(create_paint_widget(),250,0);
  nd->insert(create_palette_widget(),590,0);
  nd->insert(holder.widgets.io_widget,600,220);

  return nd;
}


void
update_draw()
{
  painter::widgets.drawing_area->request_redraw();

  update_painter();
}




