#include"animk.hpp"
#include"../webpbuffer.hpp"




Holder::
Holder()
{
  a_pos.x = 0;
  a_pos.y = 0;
  b_pos.x = 0;
  b_pos.y = 0;
}




      Paper&  Holder::get_paper(int  x, int  y)      {return cards[y][x];}
const Paper&  Holder::get_paper(int  x, int  y) const{return cards[y][x];}

      Paper&  Holder::get_a_paper()      {return cards[a_pos.y][a_pos.x];}
const Paper&  Holder::get_a_paper() const{return cards[a_pos.y][a_pos.x];}

      Paper&  Holder::get_b_paper()      {return cards[b_pos.y][b_pos.x];}
const Paper&  Holder::get_b_paper() const{return cards[b_pos.y][b_pos.x];}


void
Holder::
set_a_pos(int  x, int  y)
{
  a_pos.x = x;
  a_pos.y = y;

  painter::reset_drawing(get_a_paper());

  painter::clear_showing();

  painter::push_showing(get_a_paper());

    if((a_pos.x != b_pos.x) ||
       (a_pos.y != b_pos.y))
    {
      painter::push_showing(get_b_paper());
    }


  update_draw();
}


void
Holder::
set_b_pos(int  x, int  y)
{
  b_pos.x = x;
  b_pos.y = y;

  painter::clear_showing();

  painter::push_showing(get_a_paper());

    if((a_pos.x != b_pos.x) ||
       (a_pos.y != b_pos.y))
    {
      painter::push_showing(get_b_paper());
    }


  update_draw();
}


const SDL_Point&  Holder::get_a_pos() const{return a_pos;}
const SDL_Point&  Holder::get_b_pos() const{return b_pos;}




void
write(std::string&  buf, const char*  s)
{
    while(*s)
    {
      buf.push_back(*s++);
    }
}


bool
compare(const char*&  buf, const char*  s)
{
  auto  p = buf;

    while(*s)
    {
        if(*p++ != *s++)
        {
          return false;
        }
    }


  buf = p;

  return true;
}


enum{
  version = 0,
};


static
const char*
id = "animk";


void
Holder::
save(const char*  path) const
{
  std::string  buf;

  buf += "[animk]{\n";


  buf += "[width](";
  buf += std::to_string(w);
  buf += ")\n";

  buf += "[height](";
  buf += std::to_string(h);
  buf += ")\n";

    rep(y,h){
    rep(x,w){
      cards[y][x].write(buf);
    }}


  palette8.write(buf);

  buf += "}\n";

  save_gzfile(buf.data(),buf.size(),path);
}


void
Holder::
load(const char*  path)
{
  const Ireco*  ireco = load_ireco(path);

  int  holder_w;
  int  holder_h;

  const Ireco*  palette_ireco;

  std::vector<const Ireco*>  paper_ireco_buf;

    if(ireco->find({"animk","width" },holder_w) &&
       ireco->find({"animk","height"},holder_h) &&
       ireco->find({"animk","palette8"},palette_ireco) &&
       ireco->find({"animk"},"paper",paper_ireco_buf))
    {
      auto  p = paper_ireco_buf.data();

        rep(y,holder_h){
        rep(x,holder_w){
          cards[y][x].read(**p++);
        }}


      palette8.read(*palette_ireco);


      painter::widgets.drawing_area->request_redraw();
      palette8.widgets.area->request_redraw();
    }
}


void
Holder::
save_as_webp(const char*  path) const
{
  WebPBuffer  buf;

  buf.make(Card::w*w,Card::h*h);

    rep(y,h){
    rep(x,w){
        rep(yy,Card::h){
        rep(xx,Card::w){
          auto&   pix =         buf.get_pixel(Card::w*x+xx,Card::h*y+yy);
          auto  pppix = cards[y][x].get_pixel(          xx,          yy);

            if(pppix)
            {
              auto  color = palette8.get_color(pppix);
            
              get_rgb(color,pix.r,pix.g,pix.b);

              pix.a = 255;
            }

          else
            {
              pix.r = 0;
              pix.g = 0;
              pix.b = 0;
              pix.a = 0;
            }
        }}
    }}


  buf.save(path,true);
}





