#ifndef HOLDER_HPP
#define HOLDER_HPP


#include"card.hpp"


class
Holder
{
public:
  enum{
    w = 7,
    h = 6,
  };

private:
  Card  cards[h][w];

  SDL_Point  a_pos;
  SDL_Point  b_pos;

public:
  Holder();

        Paper&  get_paper(int  x, int  y)      ;
  const Paper&  get_paper(int  x, int  y) const;

        Paper&  get_a_paper()      ;
  const Paper&  get_a_paper() const;

        Paper&  get_b_paper()      ;
  const Paper&  get_b_paper() const;


  void               set_a_pos(int  x, int  y)      ;
  const SDL_Point&   get_a_pos(              ) const;
  void               set_b_pos(int  x, int  y)      ;
  const SDL_Point&   get_b_pos(              ) const;

  void  load(        const char*  path)      ;
  void  save(        const char*  path) const;
  void  save_as_webp(const char*  path) const;

  struct Widgets{
    Area*  drawing_area;

    Node*  table;

    Node*  io_widget;

    void  initialize();

    void  update();

    void  load(const std::string&  path);

  } widgets;

};




#endif




