#include"animk.hpp"




namespace{


TextBox*
txtbox;


void
draw(Area&  area)
{
  area.fill(palette8.get_color(0));

    rep(y,Holder::h){
    rep(x,Holder::w){
      holder.get_paper(x,y).draw(area,Card::w*x,Card::h*y,nullptr,1,palette8);
    }}


  area.draw_rect(Card::w*holder.get_a_pos().x  ,Card::h*holder.get_a_pos().y  ,Card::w  ,Card::h  ,black_color);
  area.draw_rect(Card::w*holder.get_a_pos().x+1,Card::h*holder.get_a_pos().y+1,Card::w-2,Card::h-2,white_color);
  area.draw_rect(Card::w*holder.get_b_pos().x+3,Card::h*holder.get_b_pos().y+3,Card::w-6,Card::h-6,black_color,true);
  area.draw_rect(Card::w*holder.get_b_pos().x+4,Card::h*holder.get_b_pos().y+4,Card::w-8,Card::h-8,white_color,true);
}


void
touch(Area&  area, const Mouse&  mouse)
{
  auto  pt = area.get_relative_point(mouse);

  const int  x = (pt.x/Card::w);
  const int  y = (pt.y/Card::h);

    if(mouse.test_left_pressing())
    {
      holder.set_a_pos(x,y);
    }

  else
    if(mouse.test_right_pressing())
    {
      holder.set_b_pos(x,y);
    }
}


void
save(Button&  btn)
{
    if(btn->test_pressed())
    {
      auto  s = txtbox->get();

        if(s.rfind(".animk") == std::string::npos)
        {
          s += ".animk";
        }


      holder.save(s.data());
    }
}


void
save_as_webp(Button&  btn)
{
    if(btn->test_pressed())
    {
      auto  s = txtbox->get();

        if(s.rfind(".webp") == std::string::npos)
        {
          s += ".webp";
        }


      holder.save_as_webp(s.data());
    }
}


Node*
create_io_widget()
{
  auto  col = new TableColumn;

  txtbox = new TextBox("newdata",32);

  auto  save_btn      = new RotorButton(u"save");
  auto  saveaswebp_btn = new RotorButton(u"save as webp");

  save_btn->set_callback(save);
  saveaswebp_btn->set_callback(save_as_webp);

  col->insert(txtbox);
  col->insert(save_btn);
  col->insert(saveaswebp_btn);

  return col;
}


void
copy(Button&  btn)
{
    if(btn->test_unpressed())
    {
      holder.get_a_paper() = holder.get_b_paper();

      update_draw();
    }
}


void
swap(Button&  btn)
{
    if(btn->test_unpressed())
    {
      std::swap(holder.get_a_paper(),
                holder.get_b_paper());

      update_draw();
    }
}


void
pile(Button&  btn)
{
    if(btn->test_unpressed())
    {
      holder.get_a_paper().pile(0,0,holder.get_b_paper());

      update_draw();
    }
}


}




void
Holder::Widgets::
initialize()
{
  drawing_area = new Area(Card::w*w,Card::h*h);

  drawing_area->set_draw_callback(draw);
  drawing_area->set_callback(touch);


  auto  copy_button = new Button(u"複製");
  auto  swap_button = new Button(u"交換");
  auto  pile_button = new Button(u"重ねる");

  copy_button->set_callback(copy);
  swap_button->set_callback(swap);
  pile_button->set_callback(pile);


  auto  upper_table = new TableRow;
  auto  lower_table = new TableRow;

  upper_table->insert(copy_button);
  upper_table->insert(swap_button);
  upper_table->insert(pile_button);

  io_widget = create_io_widget();

  lower_table->insert(drawing_area);


  table = new TableColumn;

  table->insert(upper_table);
  table->insert(lower_table);
}




void
Holder::Widgets::
load(const std::string&  path)
{
  holder.load(path.data());

  txtbox->set(basename(path));

                   drawing_area->request_redraw();
  painter::widgets.drawing_area->request_redraw();

  palette8.widgets.area->request_redraw();
}




