#include"color.hpp"




namespace oat{


namespace{


SDL_PixelFormat*
common_format;


}




Color
default_colors[0x8000];


const Color&    red_color = get_default_color(31, 0, 0);
const Color&  green_color = get_default_color( 0,31, 0);
const Color&   blue_color = get_default_color(31, 0,31);

enum
{
  gray_base = 24,

      light_gray_v =  4,
       dark_gray_v = -4,
  deep_dark_gray_v = -8,

};

const Color&            gray_color = get_default_color(gray_base                 );
const Color&      light_gray_color = get_default_color(gray_base+    light_gray_v);
const Color&       dark_gray_color = get_default_color(gray_base+     dark_gray_v);
const Color&  deep_dark_gray_color = get_default_color(gray_base+deep_dark_gray_v);


const Color&  get_default_color(uint8_t  r, uint8_t  g, uint8_t  b){return default_colors[((r<<10)|(g<<5)|b)&0x7FFF];}
const Color&  get_default_color(uint8_t  l                        ){return default_colors[((l<<10)|(l<<5)|l)&0x7FFF];}


void
get_rgb(uint32_t  v, uint8_t&  r, uint8_t&  g, uint8_t&  b)
{
//  SDL_GetRGB(v,common_format,&r,&g,&b);

  r = ((v>>16)&0xFF);
  g = ((v>> 8)&0xFF);
  b = ((v>> 0)&0xFF);
}


uint32_t
map_rgb(uint8_t  r, uint8_t  g, uint8_t  b)
{
//  return SDL_MapRGB(common_format,r,g,b);

  return(0xFF000000|((r<<16)|(g<<8)|b));
}


uint32_t
map_mono(uint8_t  l)
{
//  return SDL_MapRGB(common_format,l,l,l);

  return(0xFF000000|((l<<16)|(l<<8)|l));
}




namespace{


struct
Initializer
{
  Initializer();

};


Initializer::
Initializer()
{
  common_format = SDL_AllocFormat(colorformat);

    rep(r5,32){
    rep(g5,32){
    rep(b5,32){
      const uint8_t  r8 = (r5? (0b111|(r5<<3)):0);
      const uint8_t  g8 = (g5? (0b111|(g5<<3)):0);
      const uint8_t  b8 = (b5? (0b111|(b5<<3)):0);

      default_colors[(r5<<10)|(g5<<5)|b5] = SDL_MapRGB(common_format,r8,g8,b8);
    }}}
}


Initializer
init;


}




}




