#ifndef OAT_COLOR_HPP
#define OAT_COLOR_HPP


#include<SDL.h>
#include<cstdint>
#include<string>
#include"util.hpp"


namespace oat{


constexpr uint32_t  colorformat = SDL_PIXELFORMAT_ARGB8888;

using Color = uint32_t;


extern Color  default_colors[0x8000];


enum{
  black_color = 0,
  white_color = 0xFFFFFFFF,
};


extern const Color&    red_color;
extern const Color&  green_color;
extern const Color&   blue_color;

extern const Color&             gray_color;
extern const Color&       light_gray_color;
extern const Color&        dark_gray_color;
extern const Color&   deep_dark_gray_color;

const Color&  get_default_color(uint8_t  r, uint8_t  g, uint8_t  b);
const Color&  get_default_color(uint8_t  l                        );

void      get_rgb(uint32_t  v, uint8_t&  r, uint8_t&  g, uint8_t&  b);
uint32_t  map_rgb(             uint8_t   r, uint8_t   g, uint8_t   b);

uint32_t  map_mono(uint8_t  l);




}




#endif




