#include"dottle.hpp"




Paper      paper(paper_size,paper_size);
Paper::UndoBuffer  undo_buffer;


Widget*
create_palette_widget()
{
  Node*  pal = new TableRow(8,{painter::palette8.widgets.area,painter::colorchooser.widgets.node});

  return pal;
}


Widget*
create_united_widget()
{
  paper.set_undo_buffer(&undo_buffer);

  painter::set_base_mover_using();

  painter::reset_drawing(paper);
  painter::push_showing(paper);
  painter::reset_whole(paper_size,paper_size);
  painter::reset_part(32,32,8);

  painter::widgets.initialize();

  painter::colorchooser.widgets.initialize();
  painter::palette8.widgets.initialize();

  auto  node = new Node;

  auto  leftest = new TableColumn;


  leftest->insert(painter::widgets.radiobox);
  leftest->insert(painter::widgets.mirror_widget);
  leftest->insert(painter::widgets.reverse_widget);
  leftest->insert(painter::widgets.revolve_widget);
  leftest->insert(painter::widgets.shift_ud_widget);
  leftest->insert(painter::widgets.shift_lr_widget);
  leftest->insert(painter::widgets.undo_button);
  leftest->insert(painter::widgets.grid_button);
  leftest->insert(painter::widgets.copy_button);

  node->insert(leftest);


  node->insert(new TableRow(16,{painter::widgets.drawing_area,painter::widgets.part_drawing_area,create_palette_widget()}),150,0);

  node->insert(new TableColumn(8,{painter::widgets.brush_label,painter::widgets.frame_label}),160,340);


  node->insert(create_io_widget(),500,300);


  return node;
}




bool
load(const char*  path)
{
  auto  ireco = load_ireco(path);

  const Ireco*  paper_ireco;
  const Ireco*  palette_ireco;

    if(ireco->find({"dottle","paper"},paper_ireco) &&
       ireco->find({"dottle","palette8"},palette_ireco))
    {
      paper.read(*paper_ireco);
      painter::palette8.read(*palette_ireco);
    }


  return false;
}


bool
save(const char*  path)
{
  std::string  v;

  v += "[dottle]{\n";

  paper.write(v);
  painter::palette8.write(v);

  v += "}\n";

  save_gzfile((const uint8_t*)v.data(),v.size(),path);

  return true;
}






