#include"font.hpp"
#include"util.hpp"




namespace  oat{
namespace font{




int
draw_ascii(char  c, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color)
{
  auto  p = ascii::get_data(c);

  x += 2;

    rep(yy,h)
    {
      auto  code = *p++;

      auto  dst = (uint32_t*)&pixels[pitch*(y+yy)];

        rep(xx,small_w)
        {
            if(code&0x80)
            {
              dst[x+xx] = color;
            }


          code <<= 1;
        }
    }


   return font::small_w;
}


int
draw_unicode(char16_t  c, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color)
{
  auto  p = unicode::get_data(c);

    if(p)
    {
      x += 2;

        rep(yy,h)
        {
          uint16_t  code = *p++;

          auto  dst = (uint32_t*)&pixels[pitch*(y+yy)];

            rep(xx,w)
            {
                if(code&0x8000)
                {
                  dst[x+xx] = color;
                }


              code <<= 1;
            }
        }


      return font::w;
    }


  return 0;
}




void
draw_ascii(const char*  s, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color)
{
  draw_unicode(to_u16string(s).data(),pixels,pitch,x,y,color);
}


void
draw_unicode(const char16_t*  s, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color)
{
    while(*s)
    {
      auto  c = *s++;

      x += ((c <= 0xFF)?   draw_ascii(c,pixels,pitch,x,y,color)
                       : draw_unicode(c,pixels,pitch,x,y,color));
    }
}




size_t
get_width(const std::u16string&  s)
{
  size_t  v = 0;

    for(auto  c: s)
    {
      v += ((c <= 0xFF)? small_w:w);
    }


  return v;
}


}}




