#include"canvas.hpp"
#include"piece_draw.hpp"




namespace{


void
put(uint32_t*&  src, Canvas&  dst, int  x, int  y)
{
  dst.table[y][x] = src++;
}


}


void
Canvas::
reset(Piece*  _piece)
{
  piece = _piece;

    rep(y,side_length){
    rep(x,side_length){
      table[y][x] = nullptr;
    }}


  auto  p = piece->pixels;

    switch(piece->type)
    {
      case(Piece::lt):
        draw_lt(put,p,*this);
        break;
      case(Piece::gt):
        draw_gt(put,p,*this);
        break;
    }
}


void
Canvas::
draw(Area&  area)
{
  area.fill();

    rep(y,side_length){
    rep(x,side_length){
      auto  color = table[y][x];

        if(color)
        {
          area.fill_rect(pixel_size*x,
                         pixel_size*y,
                         pixel_size,
                         pixel_size,*color);
        }
    }}
}


void
Canvas::
fill_next(int  x, int  y, const Color  target_color, const Color  new_color)
{
  auto&  mark = mark_table[y][x];

    if(!mark)
    {
      mark = 1;

      auto  p = table[y][x];

        if(p && (*p == target_color))
        {
          *p = new_color;

            if(x                  ){fill_next(x-1,y  ,target_color,new_color);}
            if(y                  ){fill_next(x  ,y-1,target_color,new_color);}
            if(x < (side_length-1)){fill_next(x+1,y  ,target_color,new_color);}
            if(y < (side_length-1)){fill_next(x  ,y+1,target_color,new_color);}
        }
    }
}


void
Canvas::
fill(int  x, int  y, Color  color)
{
  auto  p = table[y][x];

    if(p && (*p != color))
    {
      std::memset(&mark_table,0,sizeof(mark_table));

      const Color  target_color = *p        ;
                                  *p = color;

      mark_table[y][x] = 1;

        if(x                  ){fill_next(x-1,y  ,target_color,color);}
        if(y                  ){fill_next(x  ,y-1,target_color,color);}
        if(x < (side_length-1)){fill_next(x+1,y  ,target_color,color);}
        if(y < (side_length-1)){fill_next(x  ,y+1,target_color,color);}
    }
}


void
Canvas::
touch(Area&  area, const SDL_Point&  pt, Color  color, bool  filling)
{
  const int  x = (pt.x/pixel_size);
  const int  y = (pt.y/pixel_size);

    if(filling)
    {
      fill(x,y,color);

      blksheet_area->request_redraw();

      area.request_redraw();
    }

  else
    {
      auto  p = table[y][x];

        if(p)
        {
          *p = color;

          blksheet_area->request_redraw();

          area.request_redraw();
        }
    }
}




