#ifndef _ISOMT_CUBE_HPP_
#define _ISOMT_CUBE_HPP_


#include"piece.hpp"
#include"sheet.hpp"




enum
CubePlaneID
{
  PLN_top,
  PLN_bottom,
  PLN_left,
  PLN_right,
  PLN_front,
  PLN_back,
  PLN_END,

};


struct
CubePlane
{
  CubePlaneID  id;

  int  visible_flag;

  Piece   first;
  Piece  second;

  void  reset(CubePlaneID  _id, SheetPiece&  first, PieceSideID  side_id);

  void  fill(Color  color);

  void  draw(void*  ptr, int  pitch) const;

};


struct
Coord
{
  int  x;
  int  y;
  int  z;

};


struct
CubeElement
{
  Coord  coord;

  CubePlane  planes[PLN_END];

  CubeElement*  linked_elements[PLN_END];

  void*  data=nullptr;

  void  make(SheetPiece&  base_piece);

  void    set(uint8_t  l);
  void  unset(          );

  void  draw(void*  ptr, int  pitch) const;

};


struct
Cube
{
  int  size;

  using ElementArray = std::vector<CubeElement>;

  ElementArray  elements;

  static void  make(Cube&  cb, Sheet&  sheet);

  void  make(Sheet&  sheet){make(*this,sheet);}

        CubeElement&  get(int  x, int  y, int  z)      {return elements[(size*size*z)+(size*y)+x];}
  const CubeElement&  get(int  x, int  y, int  z) const{return elements[(size*size*z)+(size*y)+x];}

  int  get_size() const{return size;}

  void  draw(Area&  area) const;

};


#endif




