#ifndef _ISOMT_IMAGE_HPP_
#define _ISOMT_IMAGE_HPP_


#include"piece.hpp"




struct
Image
{
  struct Bucket{
    uint8_t  r_base;
    uint8_t  g_base;
    uint8_t  b_base;
    uint8_t  x;

    uint32_t  r;
    uint32_t  g;
    uint32_t  b;

    Bucket();

  };

  const int  width;
  const int  height;
  const int  pitch;

  std::vector<Color>  pixels;

  Image(int  w, int  h);
  Image(Image&&  rhs);


        Color&  get(int  x, int  y)      ;
  const Color&  get(int  x, int  y) const;

  Color  pick(int  x, int  y) const;

  bool  pick(int  x, int  y, Bucket&  buck, int  level) const;

  Image  reduce() const;

  void  save(const char*  path) const;

};


#endif




