#include"sheet.hpp"
#include"block_sheet.hpp"
#include"canvas.hpp"
#include"image.hpp"
#include"cube.hpp"




enum{
  w = 12,
  h = w*2,

  blksheet_w = 4,
  blksheet_h = blksheet_w*2,
};


Sheet
sheet;


Cube
cube;


BlockSheet
blksheet;


Canvas
canvas;


CheckBox*
chkbox;


Area*
canvas_area;


Area*
cube_area;


void
draw(Area&  area)
{
  auto&  sht = *(Sheet*)area.get_userdata();

  sht.draw(area,true);
}


void
draw_cube(Area&  area)
{
  cube.draw(area);
}


void
touch(Area&  area, const Mouse&  mouse)
{
  auto  pt = area.get_relative_point(mouse);

    if(mouse.test_left_pressed() || (mouse.test_motion() && mouse.test_left_pressing()))
    {
      auto&  sht = *(Sheet*)area.get_userdata();

      sht.touch(area,pt,blksheet.touched_piece);

        if((&sht == &blksheet) && sht.touched_piece)
        {
          canvas.reset(sht.touched_piece);

          canvas_area->request_redraw();
        }
    }
}


void
pump(CubeElement*  elm)
{
  void*  a;
  void*  b=nullptr;

    while(elm)
    {
      a = elm->data        ;
          elm->data = b    ;
                      b = a;

      elm = elm->linked_elements[PLN_back];
    }
}


void
up()
{
  int  zn = 4;

  rep(z,zn){
  rep(x,cube.get_size()){
  auto&  elm = cube.get(x,0,z);
    pump(&elm);
    elm.data=((rand()>>4)&1)? (void*)1:nullptr;
  }}


  rep(z,zn){
  rep(y,cube.get_size()){
  rep(x,cube.get_size()){
    auto&  elm = cube.get(x,y,z);

      if(elm.data){elm.set(255-(32*z));}
    else          {elm.unset();}
  }}}


}


void
keytouch(Area&  area, const SDL_KeyboardEvent&  evt)
{
    switch(evt.type)
    {
      case(SDL_KEYUP):
          switch(evt.keysym.sym)
          {
            case(SDLK_DOWN):
              up();
              break;
          }
        break;
    }


  area.request_redraw();
}


void
canvas_draw(Area&  area)
{
  canvas.draw(area);
}


void
canvas_touch(Area&  area, const Mouse&  mouse)
{
  auto  pt = area.get_relative_point(mouse);

    if(mouse.test_left_pressed() || (mouse.test_motion() && mouse.test_left_pressing()))
    {
      canvas.touch(area,pt,0xFFFFFFFF,chkbox->get_state());
    }
}


void
fn(Button&  btn)
{
if(btn->test_unpressed())
{
int  w;
int  h;

sheet.get_image_size(w,h);

Image  img(w,h);

sheet.write_to(img);

Image  tmpimg(img.reduce());

blksheet.read_from(tmpimg);

  blksheet_area->request_redraw();
}  
}


int
main(int  argc, char**  argv)
{
     sheet.make(         w,         h);
  blksheet.make(blksheet_w,blksheet_h);

  cube.make(sheet);

  SDL_Init(SDL_INIT_VIDEO);


  sheet_area = create_area(w,h);

  sheet_area->set_draw_callback(draw);
  sheet_area->set_callback(touch);
  sheet_area->set_callback(keytouch);
  sheet_area->set_userdata(&sheet);


  blksheet_area = create_area(blksheet_w,blksheet_h);

  blksheet_area->set_draw_callback(draw);
  blksheet_area->set_callback(touch);
  blksheet_area->set_userdata(&blksheet);


  canvas_area = create_area<pixel_size>(1,1);

  canvas_area->set_draw_callback(canvas_draw);
  canvas_area->set_callback(canvas_touch);


  cube_area = create_area(w,h);

  cube_area->set_draw_callback(draw_cube);
  cube_area->set_callback(keytouch);

  sys::set_keyreceive_widget(cube_area);


  chkbox = new CheckBox;

  chkbox->push(nullptr,u"fill");


  auto  btn = new Button(u"push me");

  btn->set_callback(fn);

  auto  root = new TableColumn(24,{new TableRow(24,{sheet_area,blksheet_area,canvas_area,chkbox,btn}),cube_area});

  sys::make_window("isomt - " __DATE__,32,32,root);

    while(sys::process_event())
    {
      sys::update();

      SDL_Delay(20);
    }


  SDL_Quit();

  return 0;
}




