#include"piece.hpp"
#include"piece_draw.hpp"




void
Piece::
fill(Color  color)
{
  auto  p = pixels;

  int  n = (pixel_length);

    while(n--)
    {
      *p++ = color;
    }
}


void
Piece::
copy_from(const Color*  src)
{
    if(src)
    {
      std::memcpy(pixels,src,(sizeof(*pixels)*pixel_length));
    }
}


void
Piece::
copy_from(const void*  ptr, int  pitch)
{
  ConstSurface<uint32_t>  src(ptr,pitch);

  Color*  p = pixels;

    switch(type)
    {
      case(lt):
        draw_lt(put_surface<uint32_t>,src,p,point.x,point.y);
        break;
      case(gt):
        draw_gt(put_surface<uint32_t>,src,p,point.x,point.y);
        break;
    }
}


void
Piece::
draw(void*  ptr, int  pitch) const
{
  Surface<Color>  dst(ptr,pitch);

  const Color*  p = pixels;

    switch(type)
    {
      case(lt):
        draw_lt(put_stream<uint32_t>,p,dst,point.x,point.y);
        break;
      case(gt):
        draw_gt(put_stream<uint32_t>,p,dst,point.x,point.y);
        break;
    }
}




