#ifndef _ISOMT_PIECE_HPP_
#define _ISOMT_PIECE_HPP_


#include"../oat.hpp"


using namespace oat;


enum{
  side_length      = 24,
  side_length_half = side_length/2,
  pixel_length = side_length*side_length,

};


enum
PieceSideID
{
  SID_a,
  SID_b,
  SID_c,
  SID_END,

};


struct
Piece
{
  enum Type{
    lt,
    gt,
  } type;


  SDL_Point  point;

  Color  pixels[pixel_length];

  void  fill(Color  color);

  void  copy_from(const Color*  src);
  void  copy_from(const void*  ptr, int  pitch);

  void  draw(void*  ptr, int  pitch) const;

};




#endif




