#ifndef _ISOMT_SHEET_HPP_
#define _ISOMT_SHEET_HPP_


#include"piece.hpp"
#include"image.hpp"




template<int  PIXEL_SIZE=1>
Area*
create_area(int  w, int  h)
{
  return new Area(PIXEL_SIZE*side_length*w,PIXEL_SIZE*(side_length/2)*(h+1));
}


extern Area*     sheet_area;
extern Area*  blksheet_area;




struct
SheetPiece: public Piece
{
  struct Side{
    SheetPiece*  linked_piece;

    Color  color;
  };


  Side  sides[SID_END];

  const uint8_t*  masks;


  Side&  operator[](PieceSideID  id);

  SheetPiece*  get_linked_piece(std::initializer_list<PieceSideID>  ls);

  void  fill(Color  color);

  void  copy_from(const Color*  src);
  void  copy_from(const void*  ptr, int  pitch);

  void  reset(Color*  _pixels);

  void  draw(void*  ptr, int  pitch, bool  framing=false) const;

};


struct
Sheet
{
  SheetPiece*  touched_piece;

  int   width;
  int  height;

  std::vector<SheetPiece>  sheets;

  static std::vector<uint8_t>  lt_masks;
  static std::vector<uint8_t>  gt_masks;


  void  make_links(SheetPiece&  p, int  x, int  y);
  void  make_masks(                              );

  void  make(int  w, int  h);

        SheetPiece&  get(int  x, int  y)      ;
  const SheetPiece&  get(int  x, int  y) const;

  SheetPiece*  get_piece(const SDL_Point&  pt);

  void   draw(Area&  area, bool  framing=false);

  virtual void  touch(Area&  area, const SDL_Point&  pt, const SheetPiece*  piece);

  void  get_image_size(int&  w, int&  h) const;

  void   write_to(      Image&  img) const;
  void  read_from(const Image&  img)      ;

};




#endif




