#ifndef OAT_MENU_HPP
#define OAT_MENU_HPP


#include"util.hpp"


namespace oat{


using MenuCallback = void  (*)(int  i);

struct
MenuItem
{
  const char16_t*  const name;

  MenuCallback  const callback;

  constexpr MenuItem(const char16_t*  _name, MenuCallback  cb): name(_name), callback(cb){}


};


void  make_menu(std::initializer_list<MenuItem>  ls, int  x, int  y);

void  clean_menu();

bool  test_menu();

void  move_menu_cursor(int  cursor_y);

void  execute_menu_callback();

void  update_menu();


}




#endif




