#ifndef OAT_MOUSE_HPP
#define OAT_MOUSE_HPP


#include"util.hpp"


namespace oat{


class
Mouse
{
  uint16_t  abs_x;
  uint16_t  abs_y;

  uint8_t   left_pressing;
  uint8_t  right_pressing;

  uint8_t  tmp_flags;
  uint8_t  motion_flag;

public:
  Mouse();

  int  get_abs_x() const;
  int  get_abs_y() const;

  bool    test_left_pressing() const;
  bool    test_left_pressed() const;
  bool  test_left_unpressed() const;

  void    press_left();
  void  unpress_left();

  bool    test_right_pressing() const;
  bool    test_right_pressed() const;
  bool  test_right_unpressed() const;

  void    press_right();
  void  unpress_right();

  bool  test_motion() const;

  void  button(const SDL_MouseButtonEvent&  evt);
  void  motion(const SDL_MouseMotionEvent&  evt);

  void  clear();
  void  clean();

  void  print() const;

};


}




#endif




