#include"colorchooser.hpp"
#include"palette8.hpp"
#include"painter_private.hpp"




using namespace oat;


namespace painter{


namespace{


enum{
  l_max = 7,

};


void
update_palette(Counter&  cntr, int  newval, int  oldval)
{
  int  r = colorchooser.widgets.r_cntr->get_cur();
  int  g = colorchooser.widgets.g_cntr->get_cur();
  int  b = colorchooser.widgets.b_cntr->get_cur();

  r = (r? ((r<<5)|0b11111):0);
  g = (g? ((g<<5)|0b11111):0);
  b = (b? ((b<<5)|0b11111):0);

  palette8.set_color(r,g,b);


  painter::widgets.drawing_area->request_redraw();
  palette8.widgets.area->request_redraw();

  update();
}


}




void
ColorChooser::Widgets::
initialize()
{
  node = new Node;

  auto  r_row = new TableRow;
  auto  g_row = new TableRow;
  auto  b_row = new TableRow;

  r_cntr = new Counter(0,l_max);
  g_cntr = new Counter(0,l_max);
  b_cntr = new Counter(0,l_max);

  r_cntr->set_callback(update_palette);
  g_cntr->set_callback(update_palette);
  b_cntr->set_callback(update_palette);

  r_row->insert(new Label(u"R"));
  r_row->insert(r_cntr);
  g_row->insert(new Label(u"G"));
  g_row->insert(g_cntr);
  b_row->insert(new Label(u"B"));
  b_row->insert(b_cntr);


  node = new TableColumn;
  
  node->insert(r_row);
  node->insert(g_row);
  node->insert(b_row);
}



void
ColorChooser::Widgets::
update()
{
  uint8_t  r;
  uint8_t  g;
  uint8_t  b;

  get_rgb(palette8.get_base_color(),r,g,b);

  r_cntr->set_cur(r? (r>>5):0,false);
  g_cntr->set_cur(g? (g>>5):0,false);
  b_cntr->set_cur(b? (b>>5):0,false);
}



}





