#include"painter_private.hpp"




using namespace oat;


namespace painter{




void
set_relative_widgets(std::initializer_list<oat::Widget*>  ls)
{
  relative_widgets.assign(ls);
}


void
set_base_mover_using()
{
  base_mover_using = true;
}


void
reset_palette(Paper::Palette&  pal)
{
  palette = &pal;
}


void
reset_whole(int  w, int  h, int  pixel_size)
{
  whole_pixel_size = pixel_size;

  whole_size.x = w;
  whole_size.y = h;

  part_rect.w = w;
  part_rect.h = h;
}


void
reset_part(int  w, int  h, int  pixel_size)
{
  part_pixel_size = pixel_size;

  part_rect.x = 0;
  part_rect.y = 0;
  part_rect.w = w;
  part_rect.h = h;
}


void
reset_drawing(Paper&  _paper)
{
    if(drawing_paper)
    {
      drawing_paper->merge(string_buffer,Paper::UDO_string);
      drawing_paper->unputs(stroke_buffer);
    }


  drawing_paper = &_paper;

  frame.reset(drawing_paper->get_w(),drawing_paper->get_h());

  clear_showing();
}




void
push_showing(const Paper&  _paper)
{
  showing_papers.emplace_back(&_paper);

    if(widgets.drawing_area)
    {
      widgets.drawing_area->request_redraw();
    }
}


void
clear_showing()
{
  showing_papers.clear();

    if(widgets.drawing_area)
    {
      widgets.drawing_area->request_redraw();
    }
}


Paper*  get_drawing_paper(){return drawing_paper;}




Widgets
widgets;


}




