#ifndef _PAINTER_
#define _PAINTER_


#include"../paper.d/paper.hpp"
#include"../paper.d/paper_frame.hpp"
#include<initializer_list>




namespace painter{


void  set_relative_widgets(std::initializer_list<oat::Widget*>  ls);

void  set_base_mover_using();

void  reset_palette(Paper::Palette&  pal);

void  reset_whole(int  w, int  h, int  pixel_size=1);
void   reset_part(int  w, int  h, int  pixel_size=8);

void  reset_drawing(Paper&  _paper);

void  clear_showing();
void   push_showing(const Paper&  _paper);

void  set_base(int  x, int  y);

Paper*  get_drawing_paper();

void  update();


struct Widgets{
  oat::Area*       drawing_area;
  oat::Area*  part_drawing_area;

  oat::RadioBox*  radiobox;

  oat::Widget*  reverse_widget;
  oat::Widget*  revolve_widget;
  oat::Widget*  mirror_widget;
  oat::Widget*  shift_ud_widget;
  oat::Widget*  shift_lr_widget;
  oat::Button*  undo_button;
  oat::Button*  copy_button;
  oat::Button*  grid_button;

  oat::Label*  brush_label;
  oat::Label*  frame_label;


  void  initialize();

  void update_labels();

};


extern Widgets  widgets;


}




#endif




