#ifndef _PAINTER_PRIVATE_
#define _PAINTER_PRIVATE_


#include"painter.hpp"




namespace painter{


using namespace oat;


enum
PaintMode
{
  PAI_draw_point  = 0x01,
  PAI_draw_line   = 0x02,
  PAI_draw_circle = 0x04,
  PAI_draw_rect   = 0x08,
  PAI_fill_rect   = 0x10,
  PAI_fill_area   = 0x20,
  PAI_put_copy    = 0x40,
  PAI_set_frame   = 0x80,

};


extern Paper*                     drawing_paper;
extern std::vector<const Paper*>  showing_papers;
extern Paper::Palette*  palette;

extern std::vector<oat::Widget*>  relative_widgets;

extern Paper  copy_paper;

extern Paper::Frame  frame;

extern int  whole_pixel_size;
extern int   part_pixel_size;

extern SDL_Point  whole_size;
extern SDL_Rect    part_rect;

extern int  x_offset;
extern int  y_offset;

extern int  using_frame;
extern int  using_grid;

extern Paper::DotString  string_buffer;
extern Paper::DotString  stroke_buffer;

extern bool  base_mover_using;

extern int  state;



Widget*   create_mirror_widget();
Widget*  create_reverse_widget();
Widget*  create_revolve_widget();
Widget*  create_lrshift_widget();
Widget*  create_udshift_widget();


void  react_whole(Area&  area, const Mouse&  mouse);
void   react_part(Area&  area, const Mouse&  mouse);

void  draw_whole(Area&  area);
void   draw_part(Area&  area);


}




#endif




