#include"painter_private.hpp"




namespace painter{




namespace{




void
callback_with_rect(Button&  btn, Paper::FrameFunction  fn, bool  repeating=false)
{
    if(btn->test_pressing())
    {
      drawing_paper->merge(string_buffer,Paper::UDO_string);

      (drawing_paper->*fn)(*frame,&stroke_buffer);

      drawing_paper->merge(stroke_buffer,Paper::UDO_stroke);

      widgets.drawing_area->request_redraw();

        if(update)
        {
          update();
        }
    }
}


void    mirror_left(Button&  btn){callback_with_rect(btn,&Paper::mirror_left);}
void   mirror_upper(Button&  btn){callback_with_rect(btn,&Paper::mirror_upper);}
void   revolve_left(Button&  btn){callback_with_rect(btn,&Paper::revolve_left);}
void  revolve_right(Button&  btn){callback_with_rect(btn,&Paper::revolve_right);}
void      reverse_h(Button&  btn){callback_with_rect(btn,&Paper::reverse_h);}
void      reverse_v(Button&  btn){callback_with_rect(btn,&Paper::reverse_v);}
void       shift_up(Button&  btn){callback_with_rect(btn,&Paper::shift_up,true);}
void     shift_left(Button&  btn){callback_with_rect(btn,&Paper::shift_left,true);}
void    shift_right(Button&  btn){callback_with_rect(btn,&Paper::shift_right,true);}
void     shift_down(Button&  btn){callback_with_rect(btn,&Paper::shift_down,true);}


}


Widget*
create_mirror_widget()
{
  auto  row = new TableRow;

  auto  lb = new Label(u"ミラー");

  auto  h_btn = new Button(default_right_icon);
  auto  v_btn = new Button(default_down_icon);

  h_btn->set_callback(mirror_left);
  v_btn->set_callback(mirror_upper);

  row->insert(lb);
  row->insert(h_btn);
  row->insert(v_btn);

  return row;
}


Widget*
create_reverse_widget()
{
  auto  row = new TableRow;

  auto  lb = new Label(u"反転");

  auto  h_btn = new Button(default_ud_icon);
  auto  v_btn = new Button(default_lr_icon);

  h_btn->set_callback(reverse_h);
  v_btn->set_callback(reverse_v);

  row->insert(lb);
  row->insert(h_btn);
  row->insert(v_btn);

  return row;
}


Widget*
create_revolve_widget()
{
  auto  row = new TableRow;

  auto  lb = new Label(u"回転");

  auto  l_btn = new Button(default_left_icon);
  auto  r_btn = new Button(default_right_icon);

  l_btn->set_callback(revolve_left);
  r_btn->set_callback(revolve_right);

  row->insert(lb);
  row->insert(l_btn);
  row->insert(r_btn);

  return row;
}


Widget*
create_lrshift_widget()
{
  auto  row = new TableRow;

  auto  lb = new Label(u"左右シフト");

  auto  l_btn = new Button(default_left_icon);
  auto  r_btn = new Button(default_right_icon);

  l_btn->set_callback(shift_left,true);
  r_btn->set_callback(shift_right,true);

  row->insert(lb);
  row->insert(l_btn);
  row->insert(r_btn);

  return row;
}


Widget*
create_udshift_widget()
{
  auto  row = new TableRow;

  auto  lb = new Label(u"上下シフト");

  auto  l_btn = new Button(default_up_icon);
  auto  r_btn = new Button(default_down_icon);

  l_btn->set_callback(shift_up,true);
  r_btn->set_callback(shift_down,true);

  row->insert(lb);
  row->insert(l_btn);
  row->insert(r_btn);

  return row;
}



}




