#ifndef PAINTER_PALETTE8_HPP
#define PAINTER_PALETTE8_HPP


#include"painter.hpp"


namespace painter{


class
Palette8: public Paper::Palette
{
public:
  enum{
    w= 8,
    h=16,
  };

private:
  oat::Color  colors[h][w];

  int  x_pos;
  int  y_pos;

public:
  Palette8();


  int  get_index() const;

  int  get_x_pos() const;
  int  get_y_pos() const;

  void  set_x_pos(int  x);
  void  set_y_pos(int  y);

  oat::Color  get_base_color(      ) const;
  oat::Color  get_base_color(int  y) const;

  oat::Color   get_color(              ) const;
  oat::Color   get_color(Paper::Pixel i) const;
  oat::Color   get_color(int  x, int  y) const;

  const oat::Color*  get_pointer() const;

  void    set_color(        int  r, int  g, int  b)      ;
  void    set_color(int  y, int  r, int  g, int  b)      ;

  Paper::Pixel  make_pixel() const;

  void  find(Paper::Pixel  pix);

  void  read(const oat::Ireco&  grp);
  void  write(std::string&  buf) const;

  struct Widgets{
    oat::Area*  area;

    void  initialize();
  } widgets;

};


extern Palette8  palette8;


}




#endif




