#include"palette8.hpp"
#include"colorchooser.hpp"
#include"painter_private.hpp"




using namespace oat;


namespace painter{


namespace{


void
draw(Area&  area)
{
    rep(y,Palette8::h){
    rep(x,Palette8::w){
      area.fill_rect(font::w*x,
                     font::h*y,
                     font::w,
                     font::h,palette8.get_color(x,y));
    }}


  const int  x = (font::w*palette8.get_x_pos());
  const int  y = (font::h*palette8.get_y_pos());

  area.draw_rect(0,y  ,font::w*Palette8::w  ,font::h  ,white_color);
  area.draw_rect(1,y+1,font::w*Palette8::w-2,font::h-2,black_color);

  area.draw_rect(x+2,y+2,font::w-4,font::h-4,white_color);
  area.draw_rect(x+3,y+3,font::w-6,font::h-6,black_color);
}


void
touch(Area&  area, const Mouse&  mouse)
{
    if(mouse.test_left_pressed())
    {
      auto  pt = area.get_relative_point(mouse);

      palette8.set_x_pos(pt.x/font::w);
      palette8.set_y_pos(pt.y/font::h);

      palette8.widgets.area->request_redraw();

      colorchooser.widgets.update();
    }
}


}




void
Palette8::Widgets::
initialize()
{
  area = new Area(font::w*Palette8::w,
                  font::h*Palette8::h);

  area->set_draw_callback(draw);
  area->set_callback(touch);
}



}




