#include"paper.hpp"




using namespace oat;


void
Paper::
shift_up(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

    rep(y,rect.h-1){
    rep(x,rect.w  ){
      auto&  src = get_pixel(rect.x+x,rect.y+(y+1));

      put(rect.x+x,rect.y+y,src,buf);
    }}
}


void
Paper::
shift_left(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

    rep(y,rect.h  ){
    rep(x,rect.w-1){
      auto&  src = get_pixel(rect.x+(x+1),rect.y+y);

      put(rect.x+x,rect.y+y,src,buf);
    }}
}


void
Paper::
shift_right(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

     rep(y,rect.h  ){
    rrep(x,rect.w-1){
      auto&  src = get_pixel(rect.x+x,rect.y+y);

      put(rect.x+(x+1),rect.y+y,src,buf);
    }}
}


void
Paper::
shift_down(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

    rrep(y,rect.h-1){
     rep(x,rect.w  ){
      auto&  src = get_pixel(rect.x+x,rect.y+y);

      put(rect.x+x,rect.y+(y+1),src,buf);
    }}
}




void
Paper::
mirror_left(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_mirror_left);


  put(rect.x,rect.y,chk,buf);
}


void
Paper::
mirror_upper(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_mirror_upper);


  put(rect.x,rect.y,chk,buf);
}




void
Paper::
revolve_left(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_revolve_left);


  put(rect.x,rect.y,chk,buf);
}


void
Paper::
revolve_right(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_revolve_right);

  put(rect.x,rect.y,chk,buf);
}




void
Paper::
reverse_h(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_reverse_horizontal);

  put(rect.x,rect.y,chk,buf);
}


void
Paper::
reverse_v(const TwoPoints&  points, DotString*  buf)
{
  const auto  rect = make_rect(points);

  auto  chk = make_copy(rect,CPY_reverse_vertical);

  put(rect.x,rect.y,chk,buf);
}




