#include"paper_frame.hpp"




using namespace oat;


Paper::Frame::
Frame(int  _w, int  _h)
{
  reset(_w,_h);
}




Paper::Frame::
operator  bool() const
{
  return(x0 >= 0);
}


const TwoPoints&
Paper::Frame::
operator*() const
{
  static TwoPoints  tmp;

    if(x0 < 0)
    {
      tmp.x0 = 0  ;
      tmp.y0 = 0  ;
      tmp.x1 = w-1;
      tmp.y1 = h-1;

      return tmp;
    }


  return *this;
}




void
Paper::Frame::
reset()
{
  x0 = -1;
}


void
Paper::Frame::
reset(int  _w, int  _h)
{
  w = _w;
  h = _h;

  reset();
}


void
Paper::Frame::
set(int  x, int  y)
{
    if(x >= w)
    {
      x = w-1;
    }


    if(y >= h)
    {
      y = h-1;
    }


    if(x0 < 0)
    {
      x0 = x;
      y0 = y;
      x1 = x;
      y1 = y;
    }

  else
    {
      x1 = x;
      y1 = y;
    }
}





