#ifndef OAT_PNGBUFFER_HPP
#define OAT_PNGBUFFER_HPP


#include<cstdint>
#include<vector>
#include"util.hpp"
#include"color.hpp"


namespace oat{


class
PNGBuffer
{
public:
  enum ColorType{
    direct_color,
    indexed_color,
  };

private:
  std::vector<uint8_t>  color_table;
  std::vector<uint8_t>  index_table;

  int  w;
  int  h;

public:
  PNGBuffer(                );
  PNGBuffer(PNGBuffer&&  rhs);


  void  swap(PNGBuffer&  rhs);

  int  get_width()  const;
  int  get_height() const;

  int  get_color_number() const;

  ColorType  get_color_type() const;

  void  make_direct_color( int  _w, int  _h                                                         );
  void  make_indexed_color(int  _w, int  _h, int  color_number=256, const Color*  src_colors=nullptr);

  void  convert_to(ColorType  type);

        uint8_t*  get_index(int  x, int  y)      ;
  const uint8_t*  get_index(int  x, int  y) const;

        uint8_t*  get_color(int  x, int  y=0)      ;
  const uint8_t*  get_color(int  x, int  y=0) const;

  int  try_push(const uint8_t*  color);
  void     push(const uint8_t*  color);

  void  save(const char*  path);
  void  load(const char*  path);

};


}




#endif




