#include"storage.hpp"




namespace{


uint32_t   id_src;


}





Entry::
Entry(EntryType  type, const std::shared_ptr<Directory>&  _parent, const std::string&  _name):
entry_type(type), entry_parent(_parent), entry_name(_name), entry_id(++id_src)
{
}




bool  Entry::operator==(EntryType  _type) const{return(entry_type == _type);}
bool  Entry::operator!=(EntryType  _type) const{return(entry_type != _type);}


Directory&  Entry::as_directory(){return*(Directory*)this;}
File&            Entry::as_file(){return*(     File*)this;}
SoftLink&    Entry::as_softlink(){return*( SoftLink*)this;}
HardLink&    Entry::as_hardlink(){return*( HardLink*)this;}

const std::string  Entry::get_name() const{return entry_name;}
const Directory*  Entry::get_parent() const{return entry_parent.get();}


std::string
Entry::
to_path() const
{
  std::string  s;

  const Entry*  ent = get_parent();

    while(ent)
    {
      s += ent->get_name();

      ent = ent->get_parent();

       if(ent)
       {
         s += " -> ";
       }
    }


  return std::move(s);
}


SoftLink::
SoftLink(const std::shared_ptr<Directory>&  _parent, const std::string&  _name, const std::shared_ptr<Entry>&  _target):
Entry(ENT_softlink,_parent,_name), target(_target){}


HardLink::
HardLink(const std::shared_ptr<Directory>&  _parent, const std::string&  _name, const std::shared_ptr<Entry>&  _target):
Entry(ENT_hardlink,_parent,_name), target(_target){}


File::
File(const std::shared_ptr<Directory>&  _parent, const std::string&  _name):
Entry(ENT_file,_parent,_name){}


Directory::
Directory(const std::shared_ptr<Directory>&  _parent, const std::string&  _name):
Entry(ENT_directory,_parent,_name){}


/*
bool
compare(const std::shared_ptr<Entry>&  a, const std::shared_ptr<Entry>&  b)
{
  return(a->entry_id < b->entry_id);
}
*/




