#include"tilist.hpp"
#include"../pngbuffer.hpp"




Map::
Map()
{
  x_pos = 0;
  y_pos = 0;
}




Tile&  Map::get_tile(              ){return tiles[y_pos][x_pos];}
Tile&  Map::get_tile(int  x, int  y){return tiles[y    ][x    ];}


int  Map::get_x_pos() const{return x_pos;}
int  Map::get_y_pos() const{return y_pos;}

void  Map::set_x_pos(int  x){x_pos = x;}
void  Map::set_y_pos(int  y){y_pos = y;}


void
Map::
put(int  x, int  y, const Tile&  tile, bool  transparent)
{
  auto&  dst = tiles[y][x];

    rep(yy,Tile::size){
    rep(xx,Tile::size){
      auto&  pix = tile.get_pixel(xx,yy);

        if(!transparent || pix)
        {
          dst.get_pixel(xx,yy) = pix;
        }
    }}
}


void
Map::
shift_up(const SDL_Rect&  rect)
{
    rep(y,rect.h-1){
    rep(x,rect.w  ){
      auto&  src = get_tile(rect.x+x,rect.y+(y+1));

      put(rect.x+x,rect.y+y,src);
    }}
}


void
Map::
shift_left(const SDL_Rect&  rect)
{
    rep(y,rect.h  ){
    rep(x,rect.w-1){
      auto&  src = get_tile(rect.x+(x+1),rect.y+y);

      put(rect.x+x,rect.y+y,src);
    }}
}


void
Map::
shift_right(const SDL_Rect&  rect)
{
     rep(y,rect.h  ){
    rrep(x,rect.w-1){
      auto&  src = get_tile(rect.x+x,rect.y+y);

      put(rect.x+(x+1),rect.y+y,src);
    }}
}


void
Map::
shift_down(const SDL_Rect&  rect)
{
    rrep(y,rect.h-1){
     rep(x,rect.w  ){
      auto&  src = get_tile(rect.x+x,rect.y+y);

      put(rect.x+x,rect.y+(y+1),src);
    }}
}




void
Map::
save(const char*  path)
{
  std::string  buf;

  buf += "[tilist]{\n";

  buf += to_string("[width](%d)\n",w);
  buf += to_string("[height](%d)\n",h);

    rep(y,h){
    rep(x,w){
      tiles[y][x].write(buf);
    }}


  painter::palette8.write(buf);

  buf += "}\n";


  save_gzfile(buf.data(),buf.size(),path);
}


void
Map::
save_as_png(const char*  path)
{
  PNGBuffer  buf;

  buf.make_indexed_color(Tile::size*w,
                         Tile::size*h,Palette8::w*Palette8::h,palette8.get_pointer());


    rep(y,h){
    rep(x,w){
      auto&  src = get_tile(x,y);

        rep(yy,Tile::size){
        rep(xx,Tile::size){
          *buf.get_index((Tile::size*x)+xx,
                         (Tile::size*y)+yy) = src.get_pixel(xx,yy);

        }}
    }}


  buf.save(path);
}


void
Map::
load(const char*  path)
{
  auto  ireco = load_ireco(path);

  const Ireco*  palette_ireco;

  std::vector<const Ireco*>  paper_ireco_buf;

  int  map_w;
  int  map_h;

    if(ireco->find({"tilist","width"},map_w) &&
       ireco->find({"tilist","height"},map_h) &&
       ireco->find({"tilist","palette8"},palette_ireco) &&
       ireco->find({"tilist"},"paper",paper_ireco_buf))
    {
      auto  p = paper_ireco_buf.data();

        rep(y,h){
        rep(x,w){
          tiles[y][x].read(**p++);
        }}


      painter::palette8.read(*palette_ireco);
    }
}




