#ifndef MAP_HPP
#define MAP_HPP


#include"tile.hpp"


class
Map
{
public:
  enum{
    w = 10,
    h = 10,
  };

private:
  Tile  tiles[h][w];

  int  x_pos;
  int  y_pos;

public:
  Map();

  Tile&  get_tile(              );
  Tile&  get_tile(int  x, int  y);

  void  put(int  x, int  y, const Tile&  tile, bool  transparent=false);

  int  get_x_pos() const;
  int  get_y_pos() const;

  void  set_x_pos(int  x);
  void  set_y_pos(int  y);

  void  shift_up(   const SDL_Rect&  rect);
  void  shift_down( const SDL_Rect&  rect);
  void  shift_left( const SDL_Rect&  rect);
  void  shift_right(const SDL_Rect&  rect);

  void  save(       const char*  path);
  void  save_as_png(const char*  path);
  void  load(const char*  path);

  struct Widgets{
    Area*  area;

    TextBox*  filename_txtbox;

    Widget*  ud_shift_widget;
    Widget*  lr_shift_widget;

    Button*   copy_button;
    Button* tppaste_button;
    Button*  paste_button;

    Node*  saving_node;

    void  initialize();
  } widgets;

};




#endif




