#include"tilist.hpp"




namespace{


uint32_t
flags = 3;


void
draw_map(Area&  area)
{
  area.fill(palette8.get_color(0));

  auto  t = flags;

    rep(z,RMap::depth)
    {
        if(t&1)
        {
            rep(y,RMap::size){
            rep(x,RMap::size){
              rmap.get_tile(x,y,z).draw(area,Tile::size*x,Tile::size*y,nullptr,1,palette8);
            }}
        }


      t >>= 1;
    }


  int  x = rmap.get_x_pos();
  int  y = rmap.get_y_pos();

  area.draw_rect(Tile::size*x  ,Tile::size*y  ,Tile::size  ,Tile::size  ,white_color);
  area.draw_rect(Tile::size*x+1,Tile::size*y+1,Tile::size-2,Tile::size-2,black_color);
}


void
touch(Area&  area, const Mouse&  mouse)
{
    if(mouse.test_left_pressing())
    {
      auto  pt = area.get_relative_point(mouse);

      int  x = pt.x/Tile::size;
      int  y = pt.y/Tile::size;

      rmap.set_x_pos(x);
      rmap.set_y_pos(y);

      rmap.set_tile(x,y,rmap.get_z_pos(),*(Tile*)painter::get_drawing_paper());

      area.request_redraw();
   }
}


void
layer_change_cb(CheckBox&  box, uint32_t  newval, uint32_t  oldval)
{
  int  z = 0;

    while(!(newval&1))
    {
      newval >>= 1;

      ++z;
    }


  rmap.set_z_pos(z);
}


void
layer_cb(CheckBox&  box, uint32_t  newval, uint32_t  oldval)
{
  flags = newval;
  
  rmap.widgets.area->request_redraw();
}


}


void
RMap::Widgets::
initialize()
{
  area = new Area(Tile::size*RMap::size,
                  Tile::size*RMap::size);

  area->set_draw_callback(draw_map);
  area->set_callback(touch);


  radbox = new RadioBox;

  radbox->push(nullptr,u"layer0");
  radbox->push(nullptr,u"layer1");
  radbox->push(nullptr,u"layer2");
  radbox->push(nullptr,u"layer3");

  radbox->set_callback(layer_change_cb);


  chkbox = new CheckBox(3);

  chkbox->push(nullptr,u"layer0");
  chkbox->push(nullptr,u"layer1");
  chkbox->push(nullptr,u"layer2");
  chkbox->push(nullptr,u"layer3");

  chkbox->set_callback(layer_cb);
}




