#include"webpbuffer.hpp"
#include<cstdio>
#include<cstdlib>
#include<webp/encode.h>
#include<webp/decode.h>




namespace oat{


WebPBuffer::
WebPBuffer():
w(0),
h(0)
{
}


WebPBuffer::
WebPBuffer(WebPBuffer&&  rhs)
{
  swap(rhs);
}




void
WebPBuffer::
swap(WebPBuffer&  rhs)
{
  std::swap(pixels,rhs.pixels);

  std::swap(w,rhs.w);
  std::swap(h,rhs.h);
}


int  WebPBuffer::get_width()  const{return w;}
int  WebPBuffer::get_height() const{return h;}


      WebPBuffer::Pixel&  WebPBuffer::get_pixel(int  x, int  y)      {return pixels[(w*y)+x];}
const WebPBuffer::Pixel&  WebPBuffer::get_pixel(int  x, int  y) const{return pixels[(w*y)+x];}


void
WebPBuffer::
make(int  _w, int  _h)
{
  w = _w;
  h = _h;

  pixels.resize(w*h);
}




void
WebPBuffer::
save(const char*  path, bool  lossless) const
{
  auto  f = fopen(path,"wb");

    if(!f)
    {
      return;
    }

  size_t  size;

  const int  stride = (sizeof(Pixel)*w);

  uint8_t*  output;

    if(lossless){size = WebPEncodeLosslessRGBA((uint8_t*)pixels.data(),w,h,stride,    &output);}
  else          {size =         WebPEncodeRGBA((uint8_t*)pixels.data(),w,h,stride,0.0,&output);}


  fwrite(output,1,size,f);

  free(output);

  fclose(f);
}


void
WebPBuffer::
load(const char*  path)
{
  auto  bin = load_file(path);

  int  webp_w;
  int  webp_h;

  WebPGetInfo(bin.data(),bin.size(),&webp_w,&webp_h);

  make(webp_w,webp_h);

  WebPDecodeRGBAInto(             bin.data(),bin.size(),
                     (uint8_t*)pixels.data(),(sizeof(Pixel)*webp_w*webp_h),(sizeof(Pixel)*webp_w));
}


}




