#include"area.hpp"




namespace oat{




Area::
Area(int  w, int  h, int  margin)
{
  widget_parameter.top_margin    = margin;
  widget_parameter.left_margin   = margin;
  widget_parameter.right_margin  = margin;
  widget_parameter.bottom_margin = margin;

  widget_parameter.width  = w;
  widget_parameter.height = h;
}




void      Area::set_enter_callback(Callback  _cb){enter_cb = _cb;}
void      Area::set_leave_callback(Callback  _cb){leave_cb = _cb;}
void  Area::set_everytime_callback(Callback  _cb){everytime_cb = _cb;}
void       Area::set_draw_callback(Callback  _cb){draw_cb = _cb;}
void  Area::set_callback(MouseCallback  _cb){mouse_cb = _cb;}
void  Area::set_callback(KeyCallback  _cb){key_cb = _cb;}


void  Area::draw(){if( draw_cb){draw_cb(*this);}}


void
Area::
process(Mouse&  mouse)
{
    if(mouse_cb)
    {
      mouse_cb(*this,mouse);
    }
}


void
Area::
process(const SDL_KeyboardEvent&  evt)
{
    if(key_cb)
    {
      key_cb(*this,evt);
    }
}


void  Area::do_on_enter(){if(enter_cb){enter_cb(*this);}}
void  Area::do_on_leave(){if(leave_cb){leave_cb(*this);}}
void  Area::do_on_everytime(){if(everytime_cb){everytime_cb(*this);}}



}




