#ifndef OAT_AREA_HPP
#define OAT_AREA_HPP


#include"widget.hpp"


namespace oat{


class
Area: public Widget
{
public:
  using       Callback = void  (*)(Area&  area                     );
  using  MouseCallback = void  (*)(Area&  area, const Mouse&  mouse);
  using    KeyCallback = void  (*)(Area&  area, const SDL_KeyboardEvent&  evt);

private:
      Callback      enter_cb=nullptr;
      Callback      leave_cb=nullptr;
      Callback  everytime_cb=nullptr;

      Callback    draw_cb=nullptr;
  MouseCallback  mouse_cb=nullptr;
    KeyCallback    key_cb=nullptr;

public:
  Area(int  w, int  h, int  margin=0);


  void      set_enter_callback(Callback  _cb);
  void      set_leave_callback(Callback  _cb);
  void  set_everytime_callback(Callback  _cb);
  void       set_draw_callback(Callback  _cb);

  void  set_callback(MouseCallback  _cb);
  void  set_callback(KeyCallback  _cb);

  void  draw();
  void  process(Mouse&  mouse);
  void  process(const SDL_KeyboardEvent&  evt);

  void  do_on_enter();
  void  do_on_leave();
  void  do_on_everytime();

};




}




#endif




