#include"button_parameter.hpp"
#include<cstdio>




namespace oat{


enum{
    touched_flag = 0x01,
  untouched_flag = 0x02,
    pressed_flag = 0x04,
  unpressed_flag = 0x08,

};


ButtonParameter::
ButtonParameter()
{
  clear();
}




uint32_t  ButtonParameter::get_count() const{return count;}

bool  ButtonParameter::test_touching()  const{return touching;}
bool  ButtonParameter::test_pressing()  const{return pressing;}

bool  ButtonParameter::test_touched()   const{return(tmp_flags&  touched_flag);}
bool  ButtonParameter::test_untouched() const{return(tmp_flags&untouched_flag);}
bool  ButtonParameter::test_pressed()   const{return(tmp_flags&  pressed_flag);}
bool  ButtonParameter::test_unpressed() const{return(tmp_flags&unpressed_flag);}


void
ButtonParameter::
clear()
{
  pressing = 0;
  touching = 0;

  tmp_flags = 0;
      count = 0;
}


void
ButtonParameter::
clean()
{
  tmp_flags = 0;
}


void
ButtonParameter::
touch()
{
    if(!touching)
    {
      touching = true;

      tmp_flags |= touched_flag;
    }
}


void
ButtonParameter::
untouch()
{
    if(touching)
    {
      touching = false;

      tmp_flags |= untouched_flag;
    }
}


void
ButtonParameter::
press()
{
    if(!pressing)
    {
      pressing = true;

      tmp_flags |= pressed_flag;

      ++count;
    }
}


void
ButtonParameter::
unpress()
{
    if(pressing)
    {
      pressing = false;

      tmp_flags |= unpressed_flag;
    }
}


void
ButtonParameter::
print() const
{
  static int  n;

  printf("[button parameter %8d]\n",n++);

    if(test_touched())
    {
      printf("  touched\n");
    }


    if(test_touching())
    {
      printf("  touching\n");
    }


    if(test_untouched())
    {
      printf("  untouched\n");
    }


    if(test_pressed())
    {
      printf("  pressed\n");
    }


    if(test_pressing())
    {
      printf("  pressing\n");
    }


    if(test_unpressed())
    {
      printf("  unpressed\n");
    }
}




}




