#ifndef OAT_BUTTON_PARAMETER_HPP
#define OAT_BUTTON_PARAMETER_HPP


#include<cstdint>


namespace oat{


class
ButtonParameter
{
  uint8_t  pressing;
  uint8_t  touching;

  uint16_t  tmp_flags;
  uint32_t      count;

public:
  ButtonParameter();


  uint32_t  get_count() const;

  bool  test_touching() const;

  bool    test_touched() const;
  bool  test_untouched() const;

  bool    test_pressing() const;

  bool    test_pressed() const;
  bool  test_unpressed() const;

  void  clear();
  void  clean();

  void    touch();
  void  untouch();
  void    press();
  void  unpress();

  void  print() const;

};


}




#endif




