#ifndef OAT_CHECKBOX_HPP
#define OAT_CHECKBOX_HPP


#include"widget.hpp"
#include<vector>
#include<initializer_list>


namespace oat{


class
CheckBox: public Widget
{
public:
  using Callback = void  (*)(CheckBox&  chkbox, uint32_t  newval, uint32_t  oldval);

  using Element = std::pair<const Icon*,const char16_t*>;

protected:
  const Icon*  icon[2];

  bool  unique_flag;

  int  maxlen;

  uint32_t  state;

  std::vector<Element>  elements;

  Callback  cb=nullptr;

public:
   CheckBox(uint32_t  init_state=0);
  ~CheckBox();


  void  push(const Icon*  icon, const char16_t*  text);

  void      set_state(uint32_t  st)      ;
  uint32_t  get_state(            ) const;

  void  set_callback(Callback  _cb);

  void  draw();

  void  process(Mouse&  mouse);

};




}




#endif




