#ifndef OAT_COUNTER_HPP
#define OAT_COUNTER_HPP


#include"button.hpp"
#include"label.hpp"
#include"node.hpp"


namespace oat{


class
Counter: public Node
{
public:
  using Callback = void  (*)(Counter&  cntr, int  newval, int  oldval);

  enum Type{
    T_up_and_down,
    T_left_and_right,
  };


protected:
  Type   type;

  int  min;
  int  cur;
  int  max;
  int  step;

  Label*  cur_label;
  Label*  max_label;

  Button*  down_button;
  Button*    up_button;

  Callback  cb=nullptr;

  bool  looping_flag=false;

  void  initialize(Type  _type, int  _min, int  _max, int  _step);

public:
   Counter(             int  _min, int  _max, int  _step=1);
   Counter(Type  _type, int  _min, int  _max, int  _step=1);

  operator  int() const;

  void  set_userdata(void*  ptr, bool  spread);

  const Button&    get_up_button() const;
  const Button&  get_down_button() const;

  void  set_callback(Callback  _cb);

  const int&  get_min() const;
  const int&  get_cur() const;
  const int&  get_max() const;

  void  set_min(int  _min                   );
  void  set_cur(int  _cur, bool  use_cb=true);
  void  set_max(int  _max                   );

  void  set_looping_flag(bool  v);

  void  refresh();

  void    up();
  void  down();

};


}




#endif




