#include"label.hpp"
#include"node.hpp"
#include"util.hpp"
#include"font.hpp"




namespace oat{


Label::
Label(const std::u16string&  s, int  maxlen)
{
  fore_color = 0;

  set(s);

  widget_parameter.width  = (maxlen? font::w*maxlen:font::get_width(s));
  widget_parameter.height = font::h;
}




void
Label::
set(const std::u16string&  _s)
{
  text = _s;

  request_redraw();
}


void
Label::
printf(const char*  fmt, ...)
{
  char  buf[256];

  va_list  ap;

  va_start(ap,fmt);

  vsnprintf(buf,sizeof(buf),fmt,ap);

  va_end(ap);


  text = to_u16string(buf);

  request_redraw();
}


void
Label::
push(char16_t  c)
{
  text.push_back(c);

  request_redraw();
}


const std::u16string&
Label::
get() const
{
  return text;
}


void
Label::
draw()
{
  fill();

  draw_text(0,0,fore_color,text);
}




}




