#include"textbox.hpp"




namespace oat{


TextBox::
TextBox(const char*  s, int  max):
length_max(max? max:1)
{
  set(s? s:"");

  back_color = 0xFFFFFFFF;

  widget_parameter.width  = (font::small_w*(length_max+1))+8;
  widget_parameter.height = 24;
}




const std::string&
TextBox::
get() const
{
  return text;
}


void
TextBox::
set(const std::string&  s)
{
  text = s;

    while(text.size() > length_max)
    {
      text.pop_back();
    }


  pos = text.size();

  request_redraw();
}


void
TextBox::
draw()
{
  draw_input_form(0,0,widget_parameter.width,widget_parameter.height);

    if(test_flag(WID_ST_current_flag))
    {
      fill_rect(4+font::small_w*pos,20,font::small_w,2,black_color);
    }


  draw_text(4,8,black_color,text);
}


void
TextBox::
process(const SDL_KeyboardEvent&  evt)
{
    if(evt.type == SDL_KEYDOWN)
    {
      auto  k = evt.keysym.sym;

        if(k == SDLK_BACKSPACE)
        {
            if(text.size() && pos)
            {
              text.erase(--pos,1);
            }
        }

      else
        if(k == SDLK_DELETE)
        {
            if(text.size())
            {
              text.erase(pos,1);
            }
        }

      else
        if(k == SDLK_LEFT)
        {
            if(pos)
            {
              --pos;
            }
        }

      else
        if(k == SDLK_RIGHT)
        {
            if(pos < text.size())
            {
              ++pos;
            }
        }

      else
        if((k >= ' ') && (k <= '~'))
        {
            if(text.size() < length_max)
            {
              char  buf[2] = {(char)k,0};

                if(islower(k) && (evt.keysym.mod&KMOD_SHIFT))
                {
                  k = toupper(k);
                }


              text.insert(pos,buf);

              ++pos;
            }
        }


      request_redraw();
    }
}




}




